import LoadMaskBase from "./Group/LoadMaskBase";

export class CSMask {
	/** 遮罩Dic */
	private static _dicMask: Map<CSMask.MaskType, LoadMaskBase> = new Map();
	public static Initialize(masks: LoadMaskBase[]): void {
		this._dicMask.clear();
		for (let i = 0; i < masks.length; i++) {
			const mask: LoadMaskBase = masks[i];
			this._dicMask.set(mask.MaskType, mask);
		}
	}

	public static GetMask(type: CSMask.MaskType): LoadMaskBase {
		if (this._dicMask.has(type)) {
			return this._dicMask.get(type);
		}
		else {
			return null;
		}
	}

	public static ShowMask(type: CSMask.MaskType, ...param: any[]): void {
		let mask = this.GetMask(type);
		if (mask != null) {
			mask.Show(...param);
		}
	}

	public static HideMask(type: CSMask.MaskType, ...param: any[]): void {
		let mask = this.GetMask(type);
		if (mask != null) {
			mask.Hide(...param);
		}
	}

	public static HideAllMask(): void {
		this._dicMask.forEach((k, type) => {
			let mask: LoadMaskBase = this.GetMask(type);
			if (mask != null) {
				mask.Reset();
			}
		});
	}
}

export module CSMask {
	export enum MaskType {
		/** Loading */
		LoadingMask
	}
}
export default CSMask;
