import CSSettingsV3 from "@/FormTable/CSSettingsV3";
import { LanguageManager } from "@/FormTableExt/Manage/Language/LanguageManager";
import { ResourceInfo } from "@/define/resource";
import { backpackInfo } from "@/utils/setRPCData";
import CSResource from "../CSResource";
import IResourceItem from "../IResourceItem";
import { ResourceItemType } from "../ResourceItemType";

export default class CardCouponItem implements IResourceItem {
	public get Name(): string { return CSSettingsV3.ItemSetting.StringDetail[+CSSettingsV3.ItemSetting.CouponSetting[this.ID].CardName][LanguageManager.GetMsgId()]; }
	public get ResourceType(): ResourceItemType { return ResourceItemType.Card_Coupon; }
	public ID: number;
	public Count: number;

	public AddToResource(): void {
		backpackInfo([[this.ResourceType, [this.ID, this.Count]]], true);
		CSResource.Event.DispatchCallback(ResourceItemType.Card_Coupon, [this.ResourceType, [this.ID, this.Count]]);
	}

	/** 從db來的格式建立可數資源物件 */
	public constructor(db: ResourceInfo | JSON) {
		if (!db[1]) {
			return;
		}
		this.ID = db[1][0];
		this.Count = <number>db[1][1];
	}
}
