import CSSettingsV3 from "@/FormTable/CSSettingsV3";
import Config from "@/define/Config";
import { Shop } from "@/define/formkey";
import { ResourceInfo } from "@/define/resource";
import Player from "@/modules/player";
import { NumberEx } from "@/utils/Number/NumberEx";
import CSResource from "../CSResource";
import IResourceItem from "../IResourceItem";
import { ResourceItemType } from "../ResourceItemType";

export default class MoneyItem implements IResourceItem {
	public get Name(): string { return CSSettingsV3.prototype.ShopString(Shop.String.Money); }
	public get ResourceType(): ResourceItemType { return ResourceItemType.Money; }
	public ID: number;
	public Count: number;

	public AddToResource(): void {
		const playerData = Player.data.getState();
		playerData.account.money = NumberEx.plus(playerData.account.money, this.Count);
		Player.data.setState(playerData);
		if (Config.ShowMoneyLog) {
			console.debug(String.Format("[{0}], {1}, {2}", "Money_" + ResourceItemType.Money, playerData.account.money, this.Count));
		}
		CSResource.Event.DispatchCallback(ResourceItemType.Money, [playerData.account.money, this.Count]);
	}

	/** 從db來的格式建立可數資源物件 */
	public constructor(db: ResourceInfo | JSON) {
		this.Count = <number>db[1];
	}
}